leetcode 174 地下城游戏

一、问题描述

二、解题思路

整体思路

本题属于路径相关问题的变形,可以采用动态规划的方法来解决这个问题。

具体思路

(1)dpij含义

由于本题是具有后滞性的动态规划问题,所以不同于一般路径问题dpij表示以(i,j)为终点,本题的dpij表示以(i,j)为起点的最小生命值。

(2)状态转移方程

设当前的生命值为x,则有x+dij >= dpi+1j,即x>=dpi+1j-dij,最小生命值为dpi+1j-dij,向下亦然,所以dpij=min(dpi+1j,dpij+1)-dij。

注意:由于生命值<=0表示死亡,所以计算后需要执行dpij=max(1,dpij)。

(3)初始化

dp数组为(m+1)*(n+1)的数组,先将所有位置初始化为正无穷,(m-1,n)和(m,n-1)位置初始化为1,为了计算dpm-1n-1的值,以示例一为例,初始化后的数组为:

(4)填表顺序

从后往前,从右向左进行填写。

(5)返回值

dp00即为所求,返回即可。

三、代码实现

cpp 复制代码
class Solution {
public:
    int calculateMinimumHP(vector<vector<int>>& d) {
        //有后效性的动态规划
        int m = d.size();
        int n = d[0].size();
        vector<vector<int>> dp(m+1,vector<int>(n+1,INT_MAX));
        dp[m][n-1] = dp[m-1][n] = 1;

        //从后向前,从右向左,填写dp数组
        for(int row = m-1;row >=0;row--)
            for(int col = n-1;col >=0;col--){
                dp[row][col] = min(dp[row+1][col],dp[row][col+1])-d[row][col];
                dp[row][col] = max(1,dp[row][col]);
            }
        //返回值
        return dp[0][0];
    }
};
相关推荐
倒头就睡的小比特6 天前
算法竞赛C++常用的STL
c++·算法
weilx12346 天前
C++笔记-文件IO-<fcntl.h>
c++
小羊没烦恼!6 天前
初探性能优化——2个月到4小时的性能提升
java·开发语言·windows·算法·c#
猎头南楼6 天前
知识社区推荐系统实践:新用户冷启动与长短期兴趣建模的挑战 资深推荐算法工程师
人工智能·深度学习·算法·机器学习
Smileyqp沛沛6 天前
前端?C++ ?较大差异基础罗列
c++·基础·前端转c++
C语言小火车6 天前
C/C++ 为什么需要编译器?
开发语言·c++
旖旎夜光6 天前
力控面试题 01.01: 判定字符是否唯一(位运算) —— 题解
c++·学习·算法·leetcode·力控
wzdark6 天前
大规模并行计算中的负载均衡算法研究4
算法
吞下星星的少年·-·6 天前
C++ 萌新语法入门篇
c++·算法比赛
Because_of_Her16 天前
并查集-听课笔记
笔记·算法·并查集